<template>
  <label
      class="ach-checkbox"
      :class="{
        'ach-checkbox--disabled': disabled,
        'ach-checkbox--unchecked': !modelValue,
        'ach-checkbox--error': error
      }"
  >
    <input class="ach-checkbox__input" type="checkbox" @change="input" :checked="modelValue">
    <div class="ach-checkbox__box">
      <img src="@/assets/icons/check.svg" alt="">
    </div>
    <div class="ach-checkbox__text">
      <slot></slot>
    </div>
  </label>

</template>

<script>
export default {
  name: "AhButton",
  props: {
    modelValue: {
      type: Boolean,
      default: false
    },
    disabled: {
      type: Boolean,
      default: false
    },
    error: {
      type: Boolean,
      default: false
    }
  },
  emits: ['update:modelValue'],
  methods: {
    input(event) {
      this.$emit('update:modelValue', event.target.checked)
    }
  }
}
</script>

<style lang="scss" scoped>
$border-size: 1px;
.ach-checkbox {
  color: $x-color-full-black;
  display: flex;
  cursor: pointer;

  margin-bottom: $space-x-small;

  &:hover {
    .ach-checkbox__box {
      border: $border-size solid #FFD700;
    }
  }
}

.ach-checkbox__wrapper {
  display: flex;
  justify-content: center;
  align-items: flex-start;
}

.ach-checkbox__input {
  display: none;
}

.ach-checkbox__text {
  display: flex;
  align-items: center;
  padding-left: 10px;
  flex: 1 1 auto;
}

.ach-checkbox__box {
  display: block;
  text-align: center;
  vertical-align: middle;

  height: 29px;
  width: 29px;
  min-width: 29px;
  line-height: 29px;

  .ach-checkbox__icon {
    vertical-align: baseline;
  }


  background: #111827;
  border: $border-size solid #FFD700;
  box-sizing: border-box;
  border-radius: 5px;
}

.ach-checkbox--disabled {
  pointer-events: none;

  .ach-checkbox__box {
    background: #f5f5f5;
    .ach-checkbox__icon {
      vertical-align: baseline;
      opacity: $opacity-disabled;
    }
  }

  .ach-checkbox__text {
    color: #888888;
  }
}

.ach-checkbox--unchecked {
  .ach-checkbox__box {
    border: 1px solid #818B99;

    img {
      display: none;
    }
  }
}

.ach-checkbox--error {
  .ach-checkbox__box {
    border: 1px solid $hsl-color-red;
  }
}

</style>